#:import Factory kivy.factory.Factory

<Background@Image>:
    source: 'assets/img/bgreen.jpg'
    allow_stretch: True
    keep_ratio: False

<LayoutPopup@BoxLayout>:
    canvas.before:
        Rectangle:
            pos: self.pos
            size: self.size
            source: 'assets/img/bgreen.jpg'

# Label with black font
<BlackLabel@Label>:
    color: [0,0,0,1]

# Label with black font, small font size
# used for content
<BlackLabelSmall@BlackLabel>:
    font_size: 22
    font: 'MyriadPro-Bold.otf'
    markup: True

# Label with black font, medium font size
# used for subtitles
<BlackLabelMedium@BlackLabel>:
    font_size: 24
    font: 'MyriadPro-Bold.otf'
    markup: True

# Label with black font, large font size
<BlackLabelLarge@BlackLabel>:
    font_size: 28
    font: 'MyriadPro-Bold.otf'
    markup: True

# Label with white font, large font size
# used for titles
<WhiteLabelLarge@BlackLabel>:
    font_size: 60
    bold: True
    color: 1,1,1,1
    font: 'MyriadPro-Bold.otf'
    markup: True

<MediumButton@ColorDownButton>:
    # size_hint_x: 0.1
    size_hint_y: .8
    font_size: 30
    background_color: [0,0,0,.4]
    color: 1,1,1,1
    background_color_normal: 0,0,0,0.4
    background_color_down: 0,0,0,0.6
    font_size: 30

<FullScreenPopup@ModalView>:
    size_hint_y: 1
    size_hint_x: 1


<MainBox@BoxLayout>:
    size_hint_y: .8
    canvas.before:
        Color:
            rgba: 5,5,5,.3
        Rectangle:
            pos: self.pos
            size: self.size

<ButtonBox@BoxLayout>:
    spacing: 20
    size_hint_y: .2
    orientation: 'horizontal'

<SyncPopup@FullScreenPopup>:
    Background
    BoxLayout:
        BlackLabelLarge:
            text: app._languages[app._selected_language]["not_sync"] # + " {}/{}".format(app._sync_block, app._current_block)

<ScreenWelcome>:
    BoxLayout:
        Button:
            id: "welcome_Button"
            text: app._languages[app._selected_language]["welcome"].format(app._config.NAME)
            font_size: 20
            on_press: root.manager.current = "main"

<ScreenMain>:
    Background
    BoxLayout:
        orientation: "vertical"
        padding: 10
        BoxLayout:
            orientation: "horizontal"
            size_hint_y: .4
            BoxLayout:
                orientation: "vertical"
                size_hint_x: .3
                Image:
                    source: "assets/img/poweredbyuniswap2.png"
                BlackLabel:
                    font_size:30
                    bold: True
                    text: app._languages[app._selected_language]["main_title"].format(app._config.NAME)
            BoxLayout:
                orientation: "horizontal"
                size_hint_x: 0.7
                padding: 20

                Label:
                    size_hint_x: 0.2
                LanguageBar:

                # MediumButton:
                #     size_hint_x: .9
                #     size_hint_y: 1.5
                #     disabled: False
                #     on_press: Factory.LanguagePopup().open()
                #     text: app._languages[app._selected_language]["language"]

        ScreenManager:
            id: sm1
            size_hint_y: 2


<ScreenMenu>:
    id: menu_screen
    BoxLayout:
        orientation: "vertical"
        MainBox:
            orientation: "horizontal"
            BoxLayout:
                orientation: "vertical"
                WhiteLabelLarge:
                    size_hint_y: .15
                    text: app._languages[app._selected_language]["select_crypto"]
                BoxLayout:
                    orientation: "horizontal"
                    BoxLayout:
                        orientation: "vertical"
                        BlackLabelSmall:
                            text: 'ETHEREUM (ETH)'
                            size_hint_y: .2
                        Image:
                            source: 'assets/img/ETH-logo.png'
                            allow_stretch: True
                            size_hint_y: .5
                            keep_ratio: True
                        BlackLabelLarge:
                            text: '{} = {:.2f} CHF'.format(app._languages[app._selected_language]['buy'], app._chf_to_eth)
                            size_hint_y: .1
                        BlackLabelLarge:
                            text: '{} = {:.2f} CHF'.format(app._languages[app._selected_language]['sell'], app._eth_to_chf)
                            size_hint_y: .1
                Label:
                    size_hint_y: .1

        ButtonBox:
            MediumButton:
                text: app._languages[app._selected_language]["buy"]
                on_release:
                    root.manager.transition.direction = 'left'
                    root.manager.current = "scan_screen"
            MediumButton:
                text: app._languages[app._selected_language]["sell"]
                on_release:
                    root.manager.transition.direction = 'left'
                    root.manager.current = "sell1"
                disabled: True
            MediumButton:
                text: app._languages[app._selected_language]["redeem"]
                on_release:
                    root.manager.transition.direction = 'left'
                    root.manager.current = "redeem"
                disabled: True

<ScreenBuyScan>:
    BoxLayout:
        orientation: "vertical"
        MainBox:
            orientation: "horizontal"
            BoxLayout:
                orientation: "vertical"
                BlackLabelSmall:
                    text: app._languages[app._selected_language]["inputkey"]
                Image:
                    source: 'assets/img/phoneqr.png'
                    allow_stretch: True
                    keep_ratio: True
                BoxLayout:
                #    orientation: 'vertical'
                #    Label:
                #        font_size: '20'
                #        color: [0,0,0,1]
                #        size_hint_y : .1
                #        allow_stretch: True
                #        text: app._languages[app._selected_language]["inputwallet"]
                #    BoxLayout:
                #        size_hint_y : .2
            BoxLayout:
                size_hint_x : .1
            BoxLayout:
                orientation: "vertical"
                BoxLayout:
                    size_hint_y : .2
                BlackLabelSmall:
                    text: app._languages[app._selected_language]['camera_loading']
                    #on_press:
                    #    print(self.pos)
                    #    print(self.size)
                    #    root.manager.transition.direction = 'left'
                    #    root.manager.current = "insert_screen"
                    size_hint_x : .9
                BoxLayout:
                    size_hint_y : .2
        ButtonBox:
            MediumButton:

                text: app._languages[app._selected_language]["menu"]
                on_release:
                    root.manager.transition.direction = 'right'
                    root.manager.current = "menu"
            BoxLayout:
                orientation: "horizontal"
                size_hint_x : .2


<ScreenBuyInsert>:
    BoxLayout:
        orientation: "vertical"
        MainBox:
            orientation: "vertical"
            BoxLayout:
                size_hint_y: 0.05
            WhiteLabelLarge:
                text: app._languages[app._selected_language]["inputfiat"]
                size_hint_y: 0.1
            BoxLayout:
                orientation: "vertical"
                BoxLayout:
                    size_hint_y : .1
                BoxLayout:
                    size_hint_y : .2
                    canvas.before:
                        Color:
                            rgba: 5,5,5,.5
                        Rectangle:
                            pos: self.pos
                            size: self.size
                    BlackLabelLarge:
                        text: "{}  [b]{} CHF[/b]".format(app._languages[app._selected_language]["fiatvalue"], root._cash_in)
                BoxLayout:
                    size_hint_y : .2
                    BlackLabelLarge:
                        text: "{}  [b]{} ETH[/b]".format(app._languages[app._selected_language]["cryptovalue"], root._estimated_eth / 1e18)
                BoxLayout:
                    size_hint_y : .2
                    canvas.before:
                        Color:
                            rgba: 5,5,5,.5
                        Rectangle:
                            pos: self.pos
                            size: self.size
                    BlackLabelLarge:
                        text: "{}  [b]{} ETH[/b]".format(app._languages[app._selected_language]["cryptoslippage"], root._minimum_wei / 1e18)
                BoxLayout:
                    size_hint_y: 0.05
                BlackLabelLarge:
                    text: "{} [b]{}[/b]".format(app._languages[app._selected_language]["customeraddress"], root._address_ether)
                    size_hint_y: 0.1
                BoxLayout:
                    size_hint_y: 0.05
                    BlackLabelLarge:
                        id: buy_limit
                        color: 1,0,0,1
                        text: ""

        ButtonBox:
            MediumButton:
                text: app._languages[app._selected_language]["menu"]
                disabled: root._cash_in > 0
                on_release:
                    root._leave_without_buy()
                    root.manager.transition.direction = 'right'
                    root.manager.current = "menu"
            MediumButton:
                id: buy_confirm
                disabled: root._cash_in <= 0
                text: app._languages[app._selected_language]["confirm"]
                on_release:
                    root._buy()

<ScreenBuyFinal>:
    BoxLayout:
        orientation: "vertical"
        MainBox:
            orientation: "horizontal"
            # size_hint_x : .1
            BoxLayout:
                orientation: "vertical"
                BoxLayout:
                    size_hint_y : .2
                    WhiteLabelLarge:
                        text: app._languages[app._selected_language]["thank"]
                BoxLayout:
                    size_hint_y : .2
                    BlackLabelLarge:
                        text: "[b]{}[/b] {:.2f} CHF".format(app._languages[app._selected_language]["fiatvalue"], root._chf_sold)
                BoxLayout:
                    size_hint_y : .2
                    canvas.before:
                        Color:
                            rgba: 5,5,5,.5
                        Rectangle:
                            pos: self.pos
                            size: self.size
                    BlackLabelLarge:
                        text: "{}  [b]{:.5f} ETH[/b]".format(app._languages[app._selected_language]["cryptovalue"], root._eth_bought)
                BoxLayout:
                    size_hint_y : .2
                    BlackLabelLarge:
                        text: "{}  [b]{}[/b]".format(app._languages[app._selected_language]["customeraddress"], root._address_ether)


        ButtonBox:
            # BoxLayout:
            #     orientation: "horizontal"
            #     size_hint_x : .2
            Button:
                text: ''
                background_color: [1, 1, 1, 0]
            MediumButton:
                text: app._languages[app._selected_language]["thank"]
                on_release:
                    root.manager.transition.direction = 'right'
                    root.manager.current = "menu"
            # BoxLayout:
            #     orientation: "horizontal"
            #     size_hint_x : .2

<ScreenLoading>:
    BoxLayout:
        orientation: "vertical"
        MainBox:
            orientation: "horizontal"
            BlackLabelSmall:
                text: "Loading..."
        ButtonBox:
            BoxLayout:
                size_hint_x: .2
            MediumButton:
                text: app._languages[app._selected_language]["menu"] + " /!\\"
                on_release:
                    root.manager.transition.direction = 'right'
                    root.manager.current = "menu"
            BoxLayout:
                size_hint_x: .2

<ScreenRedeem>:
    BoxLayout:
        orientation: "vertical"
        MainBox:
            orientation: "horizontal"
            BlackLabelSmall:
                text: "Readeem Code"

        ButtonBox:
            MediumButton:

                text: app._languages[app._selected_language]["menu"]
                on_release:
                    root.manager.transition.direction = 'right'
                    root.manager.current = "menu"

            BoxLayout:
                orientation: "horizontal"
                size_hint_x : .2


<ScreenSell1>:
    BoxLayout:
        orientation: "vertical"
        MainBox:
            orientation: "vertical"
            BoxLayout:
                size_hint_y: 0.05
            WhiteLabelLarge:
                text: app._languages[app._selected_language]["sellselect"]
                size_hint_y: 0.1
            BoxLayout:
                size_hint_y: 0.05
            GridLayout:
                cols: 2
                spacing: 10
                padding:  [80, 20, 80, 20]
                #size_hint: .3,1
                MediumButton:
                    text: '10 Fr.'
                    on_release: root._sell_select(10)
                MediumButton:
                    text: '150 Fr.'
                    on_release: root._sell_select(150)
                # Label:
                #     markup: True
                #     text: '[color=ffffff]{}[/color] [color=1c6434]{}CHF[/color]'.format("1 ETH", 1)#app.l["quoteheading"], round(float(app.price["buy_price"]), 2))
                #     font_size: 35
                MediumButton:
                    text: '20 Fr.'
                    on_release: root._sell_select(20)
                MediumButton:
                    text: '200 Fr.'
                    on_release: root._sell_select(200)
                # Label:
                #     markup: True
                #     text: '[color=ffffff]{}[/color]  [color=c11d24]500CHF[/color]'.format("limit")
                #     font_size: 35
                MediumButton:
                    text: '50 Fr.'
                    on_release: root._sell_select(50)
                MediumButton:
                    text: '400 Fr.'
                    on_release: root._sell_select(400)
                # Label:
                #     text:''
                MediumButton:
                    text: '100 Fr.'
                    on_release: root._sell_select(100)
                MediumButton:
                    text: "other"
                    disabled: True
        ButtonBox:
            # BoxLayout:
            #     orientation: "horizontal"
            #     size_hint_x : .1
            MediumButton:
                text: app._languages[app._selected_language]["menu"]
                on_press:
                    root._leave_without_sell_select()
                    root.manager.transition.direction = 'right'
                    root.manager.current = "menu"
            MediumButton:
                # disabled: root._cash_in <= 0
                text: app._languages[app._selected_language]["confirm"]
                on_press:
                    root._buy()
            # BoxLayout:
            #     orientation: "horizontal"
            #     size_hint_x : .1

<ScreenSell2>:
    BoxLayout:
        orientation: "vertical"
        MainBox:
            orientation: "horizontal"
            BlackLabelSmall:
                text: "Please pay"
            Image:
                id: 'generate_qr'
                source: root._qr_image
        ButtonBox:
            MediumButton:

                text: app._languages[app._selected_language]["menu"]
                on_press:
                    root.manager.transition.direction = 'right'
                    root.manager.current = "menu"

            BoxLayout:
                orientation: "horizontal"
                size_hint_x : .2


<ScreenSettings>:
    MainBox:
        orientation: "horizontal"
        TabbedPanel:
            tab_pos: 'bottom_right'
            do_default_tab: False
            TabbedPanelItem:
                text: app._languages[app._selected_language]["connectivity"]
                MainBox:
                    Label:
                        text: "Wifi Menu"

            TabbedPanelItem:
                text: app._languages[app._selected_language]["crypto"]
                MainBox:
                    Button:
                        text: "crypto keys config"
                        on_press: root.manager.current = 'main'


<ScreenConfirmation>:
    MainBox:
        orientation: "horizontal"
